diff --git a/build_image.sh b/build_image.sh
index 086dec5924653553fa523cad66f7ca2a445cb77d..86c08b0f497daae2df2541723891187738cdf0ee 100755
--- a/build_image.sh
+++ b/build_image.sh
@@ -97,6 +97,8 @@ minimal_armel () {
 		chroot_ENABLE_DEB_SRC="${chroot_ENABLE_DEB_SRC}"
 		chroot_KERNEL_HTTP_DIR="${chroot_KERNEL_HTTP_DIR}"
 
+		chroot_cloud9_ide="${chroot_cloud9_ide}"
+
 		chroot_COPY_SETUP_SDCARD="${chroot_COPY_SETUP_SDCARD}"
 
 		chroot_hook="${chroot_hook}"
@@ -308,6 +310,7 @@ chroot_COPY_SETUP_SDCARD="enable"
 #FIXME: things to add to .config:
 include_firmware="enable"
 chroot_rcnee_startup_scripts="enable"
+#chroot_cloud9_ide="enable"
 #no_pkgs="enable"
 
 dpkg_arch="armhf"
diff --git a/scripts/chroot.sh b/scripts/chroot.sh
index 67b9e6bd8c601b425e1d5da583ed3c29b1536158..68475f217c216bbf3c6dc5bab1589a6862b822d7 100755
--- a/scripts/chroot.sh
+++ b/scripts/chroot.sh
@@ -616,6 +616,35 @@ cat > ${DIR}/chroot_script.sh <<-__EOF__
 		fi
 	}
 
+	install_cloud9 () {
+		pkg="git-core"
+		dpkg_check
+
+		if [ "x\${pkg_is_not_installed}" = "x" ] ; then
+
+			if [ "x${release}" = "xwheezy" ] ; then
+				apt-get -y -t wheezy-backports install nodejs
+			else
+				apt-get -y install nodejs
+			fi
+
+			if [ ! -f /usr/bin/node ] ; then
+				sudo ln -s /usr/bin/nodejs /usr/bin/node
+			fi
+			if [ ! -d /usr/lib/node ] ; then
+				sudo mkdir -p /usr/lib/node
+			fi
+
+			curl https://npmjs.org/install.sh | sh
+
+			mkdir -p /opt/cloud9/ || true
+			clone git clone https://github.com/ajaxorg/cloud9.git /opt/cloud9/ || true
+			chown -R ${user_name}:${user_name} /opt/cloud9/
+		else
+			dpkg_package_missing
+		fi
+	}
+
 	cleanup () {
 		mkdir -p /boot/uboot/
 
@@ -654,6 +683,10 @@ cat > ${DIR}/chroot_script.sh <<-__EOF__
 	add_user
 	startup_script
 
+	if [ "x${chroot_cloud9_ide}" = "xenable" ] ; then
+		install_cloud9
+	fi
+
 	if [ "x${chroot_ENABLE_DEB_SRC}" = "xenable" ] ; then
 		dl_pkg_src
 	fi